local Keyboard = {}
-- table of keys that have been pressed for the current frame

local key_states = {}


function Keyboard:update(dt)
  for k,v in pairs(key_states) do
    key_states[k] = nil
  end
end

--returns current state of given key
function Keyboard:key(key)
  return love.keyboard.isDown(key)
end

--returns if the key has been pressed this frame
function Keyboard:key_down(key)
  return key_states[key]
end

--returns if the key has been released this frame
function Keyboard:key_up(key)
  return key_states[key] == false
end

function Keyboard:hook_love_events()
  function love.keypressed(key, scancode, isrepeat)
    key_states[key] = true
  end
  function love.keyreleased(key, scancode)
    key_states[key] = true
  end
end


return Keyboard