local Anim = require("lib.Animation")
local Sprite = require("lib.Sprite")
local Key = require("lib.Keyboard")
local Events = require("lib.Events")
local GPM = require("lib.GamepadManager")

local hero_atlas

local spr 
local idle = Anim(16, 16, 16, 16, 4, 4, 6)
local walk = Anim(16, 32, 16, 16, {1, 2, 3, 4 , 5, 6}, 6, 12)
local swim = Anim(16, 64, 16, 16, 6, 6, 12)
local punch = Anim(16, 80, 16, 16, 3, 3, 12, false)

local snd
local e

local a = false

local gpm

function love.load()
    Key:hook_love_events()
    love.graphics.setDefaultFilter('nearest', 'nearest')
    hero_atlas = love.graphics.newImage("assets/gfx/hero.png")
    spr = Sprite(hero_atlas, 16,16,100,100, 10, 10)
    spr:add_animation("walk", walk)
    spr:add_animation("swim", swim)
    spr:add_animation("punch", punch)
    spr:add_animation("idle", idle)
    spr:animate("walk")
    
    gpm = GPM({"assets/gamecontrollerdb.txt"},{"assets/retrolinkdb.txt"})
    
    e = Events()
    e:add("on_space")
    e:hook("on_space", on_space)
    e:add("on_a")
    e:hook("on_a", on_a)
    
    snd = love.audio.newSource("assets/sfx/hits/hit01.wav", "static")
    
end

function on_space()
  love.graphics.print("Spaced!")
end

function on_a()
  print("a")
end

function love.update(dt)
  if dt > 0.035 then return end
    
  if spr.current_anim == "punch" and spr:animation_finished() then
    spr:animate("idle")
  end
  
  if Key:key_down("space") and spr.current_anim ~= "punch" then
    spr:animate("punch")
    love.audio.stop(snd)
    love.audio.play(snd)
    e:invoke("on_space")
  elseif Key:key_down("u") then
    e:unhook("on_space")
  elseif Key:key_down("escape") then
    love.event.quit()
  end
  
  if gpm:button_down(1, "a") then
    e:invoke("on_a")
  end
  
  Key:update(dt)
  spr:update(dt)
  gpm:update(dt)
end

function love.draw()
    love.graphics.clear(64/255,64/255,255/255)
    love.graphics.print(tostring(love.joystick.getJoystickCount()))
    
    love.graphics.print(tostring(GPM:button(1, "a"),70,10))
    spr:draw()
end

--function love.keypressed(key, scancode, isrepeat)
 -- if key == "space" and spr.current_anim ~= "punch" then
  --  spr:animate("punch")
  --  love.audio.stop(snd)
  --  love.audio.play(snd)
  --elseif key == "a" then
   -- spr:flip_h(true)
  --elseif key == "d" then
  --  spr:flip_h(false)
 -- elseif key == "w" then
   -- spr:flip_v(true)
 -- elseif key == "s" then
  --  spr:flip_v(false)
--  end
--end
